# ASP.NET
# Build and test ASP.NET projects.
# Add steps that publish symbols, save build artifacts, deploy, and more:
# https://docs.microsoft.com/azure/devops/pipelines/apps/aspnet/build-aspnet-4

trigger:
- master

pool:
  vmImage: 'windows-latest'

variables:
  - group: JustGo variable group

steps:


- powershell: |
   az login -u $(user) -p $(pass)
   
  displayName: 'Azure Login'

- powershell: |
   az webapp create --resource-group $(group) --plan Sandbox-Pool1 --name $(HostName)
   
  displayName: 'Creating Webapp $(HostName)'

- powershell: |
   az sql db create -g $(group) -s $(server) -n $(HostName) --elastic-pool SQL_2vCore_3Year_Test --backup-storage-redundancy Local
   
  displayName: 'Creating Database $(HostName)'

- task: SqlAzureDacpacDeployment@1
  displayName: 'Azure SQL SqlTask'
  inputs:
    azureSubscription: 'Azolve (36717786-9fde-4537-b62a-cc52f2aba3c9)'
    ServerName: ultramagnus.database.windows.net
    DatabaseName: '$(HostName)'
    SqlUsername: xxxx
    SqlPassword: xxxxxxxxxxx
    deployType: SqlTask
    SqlFile: 'Product Table.sql'

- task: Samayas.azuredevops-samayas-replaceinfiles.ReplaceInFilesBetweenText.ReplaceInFilesBetweenText@2
  displayName: 'Replace In Files Between Text'
  inputs:
    parameterSearchStart: 'Initial Catalog='
    parameterSearchEnd: ';User ID='
    parameterReplaceText: '$(HostName)'
    parameterFilesPattern: Web.config

- task: AzureCLI@2
  displayName: 'Copying Baseline to Blob Container 01'
  inputs:
    azureSubscription: 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
    scriptType: ps
    scriptLocation: inlineScript
    inlineScript: 'az storage blob upload-batch --destination data --account-name azolvetestonly --destination-path $(HostID) --source D:\a\1\s\0000000000'

- task: AzureCLI@2
  displayName: 'Copying Baseline to Blob Container 02'
  inputs:
    azureSubscription: 'xxxxxxxxxxxxxxxxxxxxxxxxxxxx'
    scriptType: ps
    scriptLocation: inlineScript
    inlineScript: 'az storage blob upload-batch --destination data1 --account-name azolvetestonly --destination-path $(HostID) --source D:\a\1\s\0000000000'

- task: NuGetToolInstaller@0
  displayName: 'Use NuGet 4.4.1'
  inputs:
    versionSpec: 4.4.1

- task: NuGetCommand@2
  displayName: 'NuGet restore'
  inputs:
    restoreSolution: '$(solution)'

- task: VSBuild@1
  displayName: 'Build solution AdventureWorks/AdventureWorks.sln'
  inputs:
    solution: '$(solution)'
    msbuildArgs: '/p:DeployOnBuild=true /p:DeployDefaultTarget=WebPublish /p:WebPublishMethod=FileSystem /p:publishUrl="$(Agent.TempDirectory)\WebAppContent\\"'
    platform: '$(buildPlatform)'
    configuration: '$(buildConfiguration)'

- task: ArchiveFiles@2
  displayName: 'Archive Files'
  inputs:
    rootFolderOrFile: '$(Agent.TempDirectory)\WebAppContent'
    includeRootFolder: false

- task: VSTest@2
  displayName: 'VsTest - testAssemblies'
  inputs:
    testAssemblyVer2: |
     **\$(BuildConfiguration)\*test*.dll
     !**\obj\**
    platform: '$(buildPlatform)'
    configuration: '$(buildConfiguration)'

- task: AzureWebApp@1
  displayName: 'Azure Web App Deploy to $(HostName)'
  inputs:
    azureSubscription: 'xxxxxxxxxxxxxxxxxxxxxxxxxxxx'
    appType: webApp
    appName: $(HostName)
    package: '$(build.artifactstagingdirectory)/**/*.zip'

- task: PublishSymbols@2
  displayName: 'Publish symbols path'
  inputs:
    SearchPattern: '**\bin\**\*.pdb'
    PublishSymbols: false
  continueOnError: true

- task: PublishBuildArtifacts@1
  displayName: 'Publish Artifact: drop'
  inputs:
    PathtoPublish: '$(build.artifactstagingdirectory)'
  condition: succeededOrFailed()
  
- bash: |

   pwd
   B64_PAT=$(printf ":$(PAT)" | base64)
   git -c http.extraHeader="Authorization: Basic ${B64_PAT}" clone https://azolvedevops@dev.azure.com/azolvedevops/JustGo/_git/onlytest
   pwd
   cd onlytest
   sed -i "/step/ { N; s/step/  - app: $(HostName)\n    db: $(HostName)\n&/ }" /d/a/1/s/onlytest/Deployment.yml
   cat Deployment.yml
   git init
   git config --global user.email "akash.paul@azolve.com"
   git config --global user.name "Akash Paul"
   git config --global --add http.https://akash.paul@azolve.com@dev.azure.com/azolvedevops/JustGo/_git/.extraHeader "AUTHORIZATION: Basic $B64Pat"
   git add Deployment.yml
   git commit -m "Adding WebApp" 
   git push https://$(PAT)@dev.azure.com/azolvedevops/JustGo/_git/onlytest HEAD:main

  displayName: 'Bash Script'
